/* This file is part of the Neper software package. */
/* Copyright (C) 2003-2013, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "net_tess_.h"

int
net_tess (struct IN In, int level, struct TESS PTess,
	  int cell, struct GERMSET *pGermSet, int TessId,
	  struct MTESS *pMTess, struct TESS *pTess)
{
  // standard tessellation
  if (!In.centroid[level])
    net_tess_standard (PTess, cell, pGermSet, TessId, pTess);

  // centroidal tessellation
  else
    net_tess_centroid (In, PTess, cell, pGermSet, TessId, pTess);

  if ((*pTess).Dim == 3)
  {
    // finalizing tessellation
    net_tess_set_domain (PTess, cell, TessId, pMTess, pTess);
    net_tess_finalize (pTess);
  }

  (*pTess).CellOri = ut_alloc_2d ((*pTess).CellQty + 1, 4);
  ut_array_2d_memcpy ((*pTess).CellOri + 1, (*pTess).CellQty, 4,
		      (*pGermSet).q + 1);

  return 0;
}
