/* This file is part of the Neper software package. */
/* Copyright (C) 2003-2013, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"neut_tess_tess_.h"

void
neut_tess_tessGen (struct TESS TessA, struct TESS *pTessB)
{
  neut_tess_tessVerQty (TessA, pTessB);
  neut_tess_tessEdgeQty (TessA, pTessB);
  neut_tess_tessFaceQty (TessA, pTessB);
  neut_tess_tessPolyQty (TessA, pTessB);

  (*pTessB).Dim = TessA.Dim;
  (*pTessB).Level = TessA.Level;
  (*pTessB).TessId = TessA.TessId;
  (*pTessB).CellQty = TessA.CellQty;

  if (TessA.Type)
    ut_string_string (TessA.Type, &((*pTessB).Type));

  if (TessA.CellId)
  {
    (*pTessB).CellId = ut_alloc_1d_int (TessA.CellQty + 1);
    ut_array_1d_int_memcpy ((*pTessB).CellId + 1, TessA.CellQty,
			    TessA.CellId + 1);
  }

  if (TessA.CellOri)
  {
    (*pTessB).CellOri = ut_alloc_2d (TessA.CellQty + 1, 4);
    ut_array_2d_memcpy ((*pTessB).CellOri + 1, TessA.CellQty, 4,
			    TessA.CellOri + 1);
  }

  return;
}

/* neut_tess_tesstializing the properties of the vertices */
void
neut_tess_tessGerm (struct TESS TessA, struct TESS *pTessB)
{
  neut_tess_tessGermCoo (TessA, pTessB);
  neut_tess_tessGermWeight (TessA, pTessB);

  return;
}

/* neut_tess_tesstializing the properties of the vertices */
void
neut_tess_tessVer (struct TESS TessA, struct TESS *pTessB)
{
  neut_tess_tessVerCoo (TessA, pTessB);
  neut_tess_tessVerEdge (TessA, pTessB);
  neut_tess_tessVerBound (TessA, pTessB);
  neut_tess_tessVerState (TessA, pTessB);

  return;
}

/* neut_tess_tesstializing the properties of the edges */
void
neut_tess_tessEdge (struct TESS TessA, struct TESS *pTessB)
{
  neut_tess_tessEdgeVerNb (TessA, pTessB);
  neut_tess_tessEdgeFace (TessA, pTessB);
  neut_tess_tessEdgeLength (TessA, pTessB);
  neut_tess_tessEdgeDel (TessA, pTessB);
  neut_tess_tessEdgeBound (TessA, pTessB);
  neut_tess_tessEdgeState (TessA, pTessB);

  return;
}

/* neut_tess_tesstializing the properties of the faces */
void
neut_tess_tessFace (struct TESS TessA, struct TESS *pTessB)
{
  neut_tess_tessFacePoly (TessA, pTessB);
  neut_tess_tessFaceVer (TessA, pTessB);
  neut_tess_tessFaceEdge (TessA, pTessB);
  neut_tess_tessFaceEq (TessA, pTessB);
  neut_tess_tessFaceBound (TessA, pTessB);
  neut_tess_tessFaceState (TessA, pTessB);
  neut_tess_tessFacePt (TessA, pTessB);

  return;
}

/* neut_tess_tesstializing the properties of the polyhedra */
void
neut_tess_tessPoly (struct TESS TessA, struct TESS *pTessB)
{
  neut_tess_tessPolyFace (TessA, pTessB);
  neut_tess_tessPolyTrue (TessA, pTessB);
  neut_tess_tessPolyBody (TessA, pTessB);

  return;
}

/* neut_tess_tesstializing the properties of the domain */
void
neut_tess_tessDomain (struct TESS TessA, struct TESS *pTessB)
{
  neut_tess_tessDomainData (TessA, pTessB);

  return;
}
